<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-231"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FGeneral%2FCategory%2FUIView%2BFadeInFadeOut.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/General/Category/UIView+FadeInFadeOut.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_3d53dd88e59abdcd55a12c7e475393fb.html">General</a></li><li class="navelem"><a class="el" href="dir_6aab43a226a6a6887d476b2e5d48e49d.html">Category</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">UIView+FadeInFadeOut.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_u_i_view_09_fade_in_fade_out_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  UIView+FadeInFadeOut.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by lele on 2017/7/19.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2017年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_u_i_view_09_fade_in_fade_out_8h.html">UIView+FadeInFadeOut.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp;<span class="preprocessor">#import &lt;objc/runtime.h&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="preprocessor">#import &lt;CKKit/CKKit.h&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp; </div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="_u_i_view_09_fade_in_fade_out_8m.html#ace13e3c0e571ea6d85de3924a3127c04">   13</a></span>&nbsp;<span class="preprocessor">#define fadeInOutDuration 0.3</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;<span class="keyword">static</span> <span class="keywordtype">char</span> kHideProcessObjectKey;</div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="category_u_i_view_07_fade_in_fade_out_08.html#a542449d60370c2a81e1969a34958630e">   16</a></span>&nbsp;<span class="keyword">static</span> <span class="keywordtype">char</span> kCompleteObjectKey;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="category_u_i_view_07_fade_in_fade_out_08.html">UIView (FadeInFadeOut)</a></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;@dynamic hideProcess;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp;@dynamic hiddenAnimationCompleted;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;- (void)setHidden:(BOOL)hidden animated:(BOOL)animated completed:(<span class="keywordtype">void</span> (^)(BOOL finish))block {</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;    [<span class="keyword">self</span> setHiddenAnimationCompleted:block];</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp;    <span class="keywordflow">if</span> (animated) {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;        [<span class="keyword">self</span>.layer pop_removeAllAnimations];</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;        <span class="keywordflow">if</span> ([[<span class="keyword">self</span> hideProcess] isEqual: [NSNumber numberWithInteger:1]]) {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;            <span class="comment">// 正在fade out</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;            [<span class="keyword">self</span> setHideProcess:[NSNumber numberWithInteger:0]];</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;            [<span class="keyword">self</span> fadeInAnimationHalf];</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp;            <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;        } <span class="keywordflow">else</span> <span class="keywordflow">if</span> ([[<span class="keyword">self</span> hideProcess] isEqual: [NSNumber numberWithInteger:0]]) {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;            <span class="comment">// 正在fade in</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;            [<span class="keyword">self</span> setHideProcess:[NSNumber numberWithInteger:1]];</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;            [<span class="keyword">self</span> fadeOutAnimationHalf];</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp;            <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;        }<span class="keywordflow">else</span> <span class="keywordflow">if</span> ([<span class="keyword">self</span> hideProcess] == nil) {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;            <span class="comment">// 不是正在动画过程中</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;        }</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;        </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp;        <span class="keywordflow">if</span> (hidden) {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp;            <span class="comment">// fade out</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;            [<span class="keyword">self</span> setHideProcess:[NSNumber numberWithInteger:1]];</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;            [<span class="keyword">self</span> fadeOutAnimation];</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;        } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;            <span class="comment">// fade in</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;            [<span class="keyword">self</span> setHideProcess:[NSNumber numberWithInteger:0]];</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;            [<span class="keyword">self</span> fadeInAnimation];</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;        }</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;        [<span class="keyword">self</span> setHidden:hidden];</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;        <span class="keywordflow">if</span> (block) {</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;            block(YES);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;        }</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;    }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;}</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp;- (void)setHidden:(BOOL)hidden animated:(BOOL)animated {</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;    [<span class="keyword">self</span> setHidden:hidden animated:animated completed:nil];</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;}</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&nbsp;- (void)fadeInAnimation {</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&nbsp;    POPBasicAnimation *fadeInAnimation = [POPBasicAnimation animationWithPropertyNamed:kPOPLayerOpacity];</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&nbsp;    fadeInAnimation.duration = <a class="code" href="_u_i_view_09_fade_in_fade_out_8m.html#ace13e3c0e571ea6d85de3924a3127c04">fadeInOutDuration</a>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&nbsp;    fadeInAnimation.fromValue = @(0.0);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp;    fadeInAnimation.toValue = @(1.0);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&nbsp;    fadeInAnimation.removedOnCompletion = NO;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&nbsp;    fadeInAnimation.delegate = <span class="keyword">self</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&nbsp;    fadeInAnimation.customTag = 500;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&nbsp;    [<span class="keyword">self</span>.layer pop_addAnimation:fadeInAnimation forKey:@&#34;fadeInAnimation&#34;];</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&nbsp;}</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&nbsp; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&nbsp;- (void)fadeInAnimationHalf {</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&nbsp;    POPBasicAnimation *fadeInAnimationHalf = [POPBasicAnimation animationWithPropertyNamed:kPOPLayerOpacity];</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&nbsp;    NSNumber *currentValue = [NSNumber numberWithFloat: self.layer.opacity];</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&nbsp;    fadeInAnimationHalf.duration = <a class="code" href="_u_i_view_09_fade_in_fade_out_8m.html#ace13e3c0e571ea6d85de3924a3127c04">fadeInOutDuration</a> * [currentValue floatValue];</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&nbsp;    fadeInAnimationHalf.fromValue = currentValue;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&nbsp;    fadeInAnimationHalf.toValue = @(1.0);</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&nbsp;    fadeInAnimationHalf.removedOnCompletion = NO;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&nbsp;    fadeInAnimationHalf.delegate = <span class="keyword">self</span>;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&nbsp;    fadeInAnimationHalf.customTag = 501;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&nbsp;    [<span class="keyword">self</span>.layer pop_addAnimation:fadeInAnimationHalf forKey:@&#34;fadeInAnimationHalf&#34;];</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&nbsp;}</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&nbsp; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&nbsp;- (void)fadeOutAnimation {</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&nbsp;    POPBasicAnimation *fadeOutAnimation = [POPBasicAnimation animationWithPropertyNamed:kPOPLayerOpacity];</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&nbsp;    fadeOutAnimation.duration = <a class="code" href="_u_i_view_09_fade_in_fade_out_8m.html#ace13e3c0e571ea6d85de3924a3127c04">fadeInOutDuration</a>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&nbsp;    fadeOutAnimation.fromValue = @(1.0);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&nbsp;    fadeOutAnimation.toValue = @(0.0);</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&nbsp;    fadeOutAnimation.removedOnCompletion = NO;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&nbsp;    fadeOutAnimation.delegate = <span class="keyword">self</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&nbsp;    fadeOutAnimation.customTag = 502;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&nbsp;    [<span class="keyword">self</span>.layer pop_addAnimation:fadeOutAnimation forKey:@&#34;fadeOutAnimation&#34;];</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&nbsp;}</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&nbsp; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&nbsp;- (void)fadeOutAnimationHalf {</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&nbsp;    POPBasicAnimation *fadeOutAnimationHalf = [POPBasicAnimation animationWithPropertyNamed:kPOPLayerOpacity];</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&nbsp;    NSNumber *currentValue = [NSNumber numberWithFloat: self.layer.opacity];</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&nbsp;    fadeOutAnimationHalf.duration = <a class="code" href="_u_i_view_09_fade_in_fade_out_8m.html#ace13e3c0e571ea6d85de3924a3127c04">fadeInOutDuration</a> * [currentValue floatValue];</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&nbsp;    fadeOutAnimationHalf.fromValue = currentValue;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&nbsp;    fadeOutAnimationHalf.toValue = @(0.0);</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&nbsp;    fadeOutAnimationHalf.removedOnCompletion = NO;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&nbsp;    fadeOutAnimationHalf.delegate = <span class="keyword">self</span>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&nbsp;    fadeOutAnimationHalf.customTag = 503;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&nbsp;    [<span class="keyword">self</span>.layer pop_addAnimation:fadeOutAnimationHalf forKey:@&#34;fadeOutAnimationHalf&#34;];</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&nbsp;}</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&nbsp; </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&nbsp;- (void)pop_animationDidStart:(POPAnimation *)anim {</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&nbsp;    anim = (POPBasicAnimation *)anim;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&nbsp;    <span class="keywordflow">if</span> (anim.customTag == 500 || anim.customTag == 501) {</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&nbsp;        <span class="comment">// 目前是隐藏的，要显示</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&nbsp;        <span class="keyword">self</span>.hidden = NO;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&nbsp;    }</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&nbsp;}</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&nbsp; </div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&nbsp;-(void)pop_animationDidStop:(POPAnimation *)anim finished:(BOOL)finished {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&nbsp;    <span class="keywordflow">if</span> (finished) {</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&nbsp;        anim = (POPBasicAnimation *)anim;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&nbsp;        <span class="keywordflow">if</span> (anim.customTag == 502 || anim.customTag == 503) {</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&nbsp;            <span class="comment">// 正在隐藏，动画已经结束，要隐藏</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&nbsp;            <span class="keyword">self</span>.hidden = YES;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&nbsp;            [<span class="keyword">self</span> setHideProcess:nil];</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&nbsp;        } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (anim.customTag == 500 || anim.customTag == 501) {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&nbsp;            <span class="keyword">self</span>.hidden = NO;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&nbsp;            [<span class="keyword">self</span> setHideProcess:nil];</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&nbsp;        }</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&nbsp;    }</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&nbsp;    void(^complete)(BOOL finished) = [<span class="keyword">self</span> hiddenAnimationCompleted];</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&nbsp;    <span class="keywordflow">if</span> (complete) {</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&nbsp;        complete(finished);</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&nbsp;    }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&nbsp;}</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&nbsp; </div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&nbsp;- (NSNumber *)hideProcess {</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&nbsp;    <span class="keywordflow">return</span> objc_getAssociatedObject(<span class="keyword">self</span>, &amp;kHideProcessObjectKey);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&nbsp;}</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&nbsp; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&nbsp;- (void)setHideProcess:(NSNumber *)hideProcess {</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&nbsp;    objc_setAssociatedObject(<span class="keyword">self</span>, &amp;kHideProcessObjectKey, hideProcess, OBJC_ASSOCIATION_RETAIN_NONATOMIC);</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&nbsp;}</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&nbsp; </div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&nbsp;- (<span class="keywordtype">void</span> (^)(BOOL finished))hiddenAnimationCompleted {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&nbsp;    <span class="keywordflow">return</span> objc_getAssociatedObject(<span class="keyword">self</span>, &amp;kCompleteObjectKey);</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&nbsp;}</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&nbsp; </div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&nbsp;- (void)setHiddenAnimationCompleted:(<span class="keywordtype">void</span> (^)(BOOL finished))completed {</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&nbsp;    objc_setAssociatedObject(<span class="keyword">self</span>, &amp;kCompleteObjectKey, completed, OBJC_ASSOCIATION_RETAIN_NONATOMIC);</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&nbsp;}</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&nbsp; </div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="a_u_i_view_09_fade_in_fade_out_8h_html"><div class="ttname"><a href="_u_i_view_09_fade_in_fade_out_8h.html">UIView+FadeInFadeOut.h</a></div></div>
<div class="ttc" id="a_u_i_view_09_fade_in_fade_out_8m_html_ace13e3c0e571ea6d85de3924a3127c04"><div class="ttname"><a href="_u_i_view_09_fade_in_fade_out_8m.html#ace13e3c0e571ea6d85de3924a3127c04">fadeInOutDuration</a></div><div class="ttdeci">#define fadeInOutDuration</div><div class="ttdef"><b>Definition:</b> <a href="_u_i_view_09_fade_in_fade_out_8m_source.html#l00013">UIView+FadeInFadeOut.m:13</a></div></div>
<div class="ttc" id="acategory_u_i_view_07_fade_in_fade_out_08_html"><div class="ttname"><a href="category_u_i_view_07_fade_in_fade_out_08.html">UIView(FadeInFadeOut)</a></div><div class="ttdef"><b>Definition:</b> <a href="_u_i_view_09_fade_in_fade_out_8h_source.html#l00012">UIView+FadeInFadeOut.h:12</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>